<?php
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//
// $Id: coreconfigsnapshots.php 240 2010-08-02 19:21:38Z egalstad $

require_once(dirname(__FILE__).'/../includes/common.inc.php');

// initialization stuff
pre_init();

// start session
init_session();

// grab GET or POST variables 
grab_request_vars();

// check prereqs
check_prereqs();

// check authentication
check_authentication(false);

// only admins can access this page
if(is_admin()==false){
	echo $lstr['NotAuthorizedErrorText'];
	exit();
	}

// route request
route_request();


function route_request(){
	global $request;
	
//	if(in_demo_mode()==true)
	//	header("Location: main.php");
		
	if(isset($request["download"]))
		do_download();
	else if(isset($request["view"]))
		do_view();
	else if (isset($request["delete"]))
		do_delete();
	else
		show_log();
	
	exit;
	}
	
	
function show_log($error=false,$msg=""){
	global $request;
	global $lstr;
	

	$snapshots=get_nagioscore_config_snapshots();
	

	do_page_start(array("page_title"=>$lstr['CoreConfigSnapshotsPageTitle']),true);

?>

	
	<h1><?php echo $lstr['CoreConfigSnapshotsPageHeader'];?></h1>
	

<?php
	display_message($error,false,$msg);
?>

	<?php echo $lstr['CoreConfigSnapshotsPageNotes'];?>
	
	<br><br>

	
	<?php 
		//print_r($snapshots);
	?>

	<table class="standardtable">
	<thead> 
	<tr><th><?php echo $lstr['DateTableHeader'];?></th><th><?php echo $lstr['SnapshotResultTableHeader'];?></th><th><?php echo $lstr['FileTableHeader'];?></th><th><?php echo $lstr['ActionsTableHeader'];?></th></tr>
	</thead>
	<tbody>
	
<?php
	$x=0;
	foreach($snapshots as $snapshot){
	
		$x++;
	
		$resultstring="Config Ok";
		$rowclass="";
		$qstring="result=ok";
		if($snapshot["error"]==true){
			$resultstring="Config Error";
			$rowclass="alert";
			$qstring="result=error";
			}
			
		if(($x%2)!=0)
			$rowclass.=" odd";
		else
			$rowclass.=" even";
	
		echo "<tr class=".$rowclass.">";
		echo "<td>".$snapshot["date"]."</td>";
		echo "<td>".$resultstring."</td>";
		echo "<td>".$snapshot["file"]."</td>";
		echo "<td>";
		echo "<a href='?download=".$snapshot["timestamp"]."&".$qstring."'><img src='".theme_image("download.png")."' alt='".$lstr['DownloadAlt']."' title='".$lstr['DownloadAlt']."'></a> ";
		echo "<a href='?view=".$snapshot["timestamp"]."&".$qstring."'><img src='".theme_image("detail.png")."' alt='".$lstr['ViewOutputAlt']."' title='".$lstr['ViewOutputAlt']."'></a>";
		if($snapshot["error"]==true)
			echo "<a href='?delete=".$snapshot["timestamp"]."'><img src='".theme_image("delete.png")."' alt='".$lstr['DeleteAlt']."' title='".$lstr['DeleteAlt']."'></a>";
		echo "</td>";
		echo "</tr>\n";
		}
?>
	
	</tbody>
	</table>

<?php

	do_page_end(true);
	exit();
	}

function do_download(){
	global $cfg;
	
	$result=grab_request_var("result","ok");
	$ts=grab_request_var("download","");
	
	// base checkpoints dir
	$dir=$cfg['nom_checkpoints_dir'];
	if($result=="error")
		$dir.="errors/";
		
	// clean the timestamp
	$ts=str_replace(".","",$ts);
	$ts=str_replace("/","",$ts);
	$ts=str_replace("\\","",$ts);
	
	$thefile=$dir.$ts.".tar.gz";
	
	header('Content-type: application/x-gzip');
	header("Content-length: " . filesize($thefile)); 
	header('Content-Disposition: attachment; filename="'.basename($thefile).'"');
	readfile($thefile); 
	exit();
	}
	
function do_view(){
	global $cfg;
	
	$result=grab_request_var("result","ok");
	$ts=grab_request_var("view","");
	
	// base checkpoints dir
	$dir=$cfg['nom_checkpoints_dir'];
	if($result=="error")
		$dir.="errors/";
		
	// clean the timestamp
	$ts=str_replace(".","",$ts);
	$ts=str_replace("/","",$ts);
	$ts=str_replace("\\","",$ts);
	
	$thefile=$dir.$ts.".txt";
	
	header('Content-type: application/text');
	header("Content-length: " . filesize($thefile)); 
	header('Content-Disposition: attachment; filename="'.basename($thefile).'"');
	readfile($thefile); 
	exit();
	}

function do_delete(){
	global $cfg;
	global $lstr;
	global $request;
	
	// demo mode
	if(in_demo_mode()==true)
		show_log(true,$lstr['DemoModeChangeError']);

	$ts=grab_request_var("delete","");
		
	// clean the filename
	$ts=str_replace("..","",$ts);
	$ts=str_replace("/","",$ts);
	$ts=str_replace("\\","",$ts);
	
	if($ts=="")
		show_log();
		
	$id=submit_command(COMMAND_DELETE_CONFIGSNAPSHOT,$ts);
	if($id<=0)
		show_log(true,$lstr['ErrorSubmittingCommandText']);
	else{
		for($x=0;$x<14;$x++){
			$status_code=-1;
			$result_code=-1;
			$args=array(
				"cmd" => "getcommands",
				"command_id" => $id,
				);
			$xml=get_backend_xml_data($args);
			if($xml){
				if($xml->command[0]){
					$status_code=intval($xml->command[0]->status_code);
					$result_code=intval($xml->command[0]->result_code);
					}
				}
			if($status_code==2){
				show_log(false,$lstr['ConfigSnapshotDeletedText']);
				exit();
				}
			usleep(500000);
			}
		}
	show_log(false,$lstr['ConfigSnapshotScheduledForDeletionText']);
	exit();
	}
	

?>