<?php
// Nagios Core Config Sub-Component Functions
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: applyconfig.php 306 2010-09-14 20:20:48Z egalstad $

include_once(dirname(__FILE__).'/../componenthelper.inc.php');


// initialization stuff
pre_init();

// start session
init_session();

// grab GET or POST variables 
grab_request_vars();

// check prereqs
check_prereqs();

// check authentication
check_authentication(false);

if(is_authorized_to_configure_objects()==false){
	echo "Not authorized";
	exit();
	}

route_request();

function route_request(){

	$cmd=grab_request_var("cmd","");
	
	switch($cmd){
		case "confirm":
			nagioscorecfg_confirm_apply();
			break;
		default:
			nagioscorecfg_apply_config();
			break;
		}
	}
	
function nagioscorecfg_apply_config(){
	global $lstr;
	
	$return_url=grab_request_var("return","");

	do_page_start(array("page_title"=>$lstr['ApplyingNagiosCoreConfigPageTitle']),true);
	
?>


<h1><?php echo $lstr['ApplyingNagiosCoreConfigPageTitle'];?></h1>




<ul class="commandresult">
<?php
	$error=false;
	$id=submit_command(COMMAND_NAGIOSCORE_APPLYCONFIG);
	//echo "COMMAND ID: $id<BR>";
	if($id>0){
		echo "<li class='commandresultok'>"."Command submitted for processing..."."</li>\n";
	
		echo "<li class='commandresultwaiting' id='commandwaiting'>"."Waiting for configuration verification...</li>"."</li>\n";
		}
	else{
		echo "<li class='commandresulterror'>"."An error occurred during command submission.  If this problem persists, contact your Nagios administrator.</li>\n";
		$error=true;
		}
?>
</ul>



<div id="commandsuccesscontent" style="visibility: hidden;">
<?php
	echo "<p>\n";
	echo $lstr['ApplyConfigSuccessMessage'];
	if(is_admin()==true){
		echo "<p><a href='".get_base_url()."admin/?xiwindow=coreconfigsnapshots.php' target='_top'>".$lstr['ViewConfigSuccessSnapshotMessage']."</a></p>";
		}
	if($return_url!=""){
		echo "<p>\n";
		echo "<form method='get' action='".htmlentities($return_url)."'><input type='submit' name='continue' value='".$lstr['ContinueText']."'></form>\n";
		}
?>
</div>
<div id="commanderrorcontent" style="visibility: hidden;">
<?php
		echo "<p>\n";
		echo $lstr['ApplyConfigErrorMessage'];
		echo "<p>\n";
		if(is_admin()==true){
			echo "<p><a href='".get_base_url()."admin/?xiwindow=coreconfigsnapshots.php' target='_top'>".$lstr['ViewConfigErrorSnapshotMessage']."</a></p>";
			}
		echo "<form method='post' action=''><input type='hidden' name='cmd' value=''><input type='submit' name='continue' value='".$lstr['TryAgainText']."'></form>\n";
?>
</div>

<script type="text/javascript">

get_apply_config_result(<?php echo $id;?>);

function get_apply_config_result(command_id){

	$(this).everyTime(1 * 1000, "commandstatustimer", function(i) {
	
		$(".commandresultwaiting").append(".");

		var csdata=get_ajax_data("getcommandstatus",command_id);
		eval('var csobj='+csdata);
		if(csobj.status_code==2){
			if(csobj.result_code==0){
				$('.commandresultwaiting').each(function(){
					$(this).removeClass("commandresultwaiting");
					$(this).addClass("commandresultok");
					});
				$('#commandsuccesscontent').each(function(){
					$(this).css("visibility","visible");
					});
				$('ul.commandresult').append("<li class='commandresultok'>Configuration applied successfully.</li>");
				}
			else{
				$('.commandresultwaiting').each(function(){
					$(this).removeClass("commandresultwaiting");
					$(this).addClass("commandresulterror");
					});
				$('#commandsuccesscontent').each(function(){
					$(this).css("display","none")
					});
				$('#commanderrorcontent').each(function(){
					$(this).css("visibility","visible")
					});
				$('ul.commandresult').append("<li class='commandresulterror'>Configuration verification failed.</li>");
				}
			$(this).stopTime("commandstatustimer");
			}
		});
		
	}
</script>

<?php
	do_page_end(true);
	}
	
	

function nagioscorecfg_confirm_apply(){
	global $lstr;
	
	do_page_start(array("page_title"=>$lstr['ApplyNagiosCoreConfigPageTitle']),true);
	
	//print_r($dashlets);
?>


<h1><?php echo $lstr['ApplyNagiosCoreConfigPageTitle'];?></h1>


<p>
<?php echo $lstr['ApplyNagiosCoreConfigMessage'];?>
</p>

<p>
<?php
	echo "<form method='post' action=''><input type='hidden' name='cmd' value=''><input type='submit' name='continue' value='".$lstr['ApplyConfigText']."'></form>\n";
?>

<?php
	do_page_end(true);
	}

?>